<template>
  <div v-if="value != null" class="mt-8">
    <div ref="partrequesttopform" />
    <v-row dense>
      <v-col cols="12">
        <v-menu offset-y max-width="600px">
          <template v-slot:activator="{ on, attrs }">
            <div class="text-h6">
              <v-icon large :color="hasData ? 'primary' : null" class="mr-2"
                >$ayiParachuteBox</v-icon
              >
              {{ $ay.t("WorkOrderItemPartRequestList") }}
              <v-btn v-if="!parentDeleted" large icon v-bind="attrs" v-on="on">
                <v-icon small color="primary">$ayiEllipsisV</v-icon>
              </v-btn>
            </div>
          </template>
          <v-list>
            <v-list-item v-if="canDelete && isDeleted" @click="unDeleteItem">
              <v-list-item-icon>
                <v-icon>$ayiTrashRestoreAlt</v-icon>
              </v-list-item-icon>
              <v-list-item-title>{{ $ay.t("Undelete") }}</v-list-item-title>
            </v-list-item>
            <v-list-item v-if="canDelete && !isDeleted" @click="deleteItem">
              <v-list-item-icon>
                <v-icon>$ayiTrashAlt</v-icon>
              </v-list-item-icon>
              <v-list-item-title>{{ $ay.t("SoftDelete") }}</v-list-item-title>
            </v-list-item>
            <v-list-item v-if="canDeleteAll" @click="deleteAllItem">
              <v-list-item-icon>
                <v-icon>$ayiDumpster</v-icon>
              </v-list-item-icon>
              <v-list-item-title>{{
                $ay.t("SoftDeleteAll")
              }}</v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
      </v-col>

      <template v-if="hasData">
        <!-- ############################################################### -->
        <v-col cols="12" class="mb-10">
          <v-data-table
            v-model="selectedRow"
            :headers="headerList"
            :items="itemList"
            item-key="index"
            class="elevation-1"
            disable-pagination
            disable-filtering
            disable-sort
            hide-default-footer
            data-cy="partRequestsTable"
            dense
            :item-class="itemRowClasses"
            :show-select="$vuetify.breakpoint.xs"
            single-select
            @click:row="handleRowClick"
          >
            <template v-slot:[`item.purchaseOrderOnOrderViz`]="{ item }">
              <v-simple-checkbox
                v-model="item.purchaseOrderOnOrderViz"
                disabled
              ></v-simple-checkbox>
            </template>

            <template v-slot:[`item.purchaseOrderViz`]="{ item }">
              <div class="subtitle-1" @click="openPO(item)">
                <a href="javascript:"> {{ item.purchaseOrderViz }}</a>
              </div>
            </template>
          </v-data-table>
        </v-col>
      </template>
      <template v-if="hasData && hasSelection">
        <v-btn
          v-if="canDelete && isDeleted"
          large
          color="primary"
          @click="unDeleteItem"
          >{{ $ay.t("Undelete")
          }}<v-icon right large>$ayiTrashRestoreAlt</v-icon></v-btn
        >
      </template>
    </v-row>
  </div>
</template>
<script>
export default {
  props: {
    value: {
      default: null,
      type: Object
    },
    pvm: {
      default: null,
      type: Object
    },
    activeWoItemIndex: {
      default: null,
      type: Number
    },
    gotoIndex: {
      default: null,
      type: Number
    }
  },
  data() {
    return {
      activeItemIndex: null,
      selectedRow: []
    };
  },
  computed: {
    isDeleted: function() {
      if (
        this.value.items[this.activeWoItemIndex].partRequests[
          this.activeItemIndex
        ] == null
      ) {
        this.setDefaultView();
        return true;
      }
      return (
        this.value.items[this.activeWoItemIndex].partRequests[
          this.activeItemIndex
        ].deleted === true
      );
    },
    parentDeleted: function() {
      return this.value.items[this.activeWoItemIndex].deleted === true;
    },

    headerList: function() {
      const headers = [];

      if (this.form().showMe(this, "WorkOrderItemPartRequestPartID")) {
        headers.push({
          text: this.$ay.t("WorkOrderItemPartRequestPartID"),
          align: "left",
          value: "partNameViz"
        });
      }

      if (
        this.form().showMe(this, "WorkOrderItemPartRequestPartWarehouseID") &&
        !this.value.userIsRestrictedType
      ) {
        headers.push({
          text: this.$ay.t("WorkOrderItemPartRequestPartWarehouseID"),
          align: "left",
          value: "partWarehouseViz"
        });
      }

      if (this.form().showMe(this, "WorkOrderItemPartRequestQuantity")) {
        headers.push({
          text: this.$ay.t("WorkOrderItemPartRequestQuantity"),
          align: "right",
          value: "quantity"
        });
      }

      if (this.form().showMe(this, "PartDescription")) {
        headers.push({
          text: this.$ay.t("PartDescription"),
          align: "left",
          value: "partDescriptionViz"
        });
      }

      if (this.form().showMe(this, "PartRequestPartUPC")) {
        headers.push({
          text: this.$ay.t("PartUPC"),
          align: "left",
          value: "upcViz"
        });
      }

      if (
        this.form().showMe(this, "WorkOrderItemPartRequestPurchaseOrder") &&
        !this.value.userIsRestrictedType
      ) {
        headers.push({
          text: this.$ay.t("PurchaseOrder"),
          align: "left",
          value: "purchaseOrderViz"
        });
      }

      if (
        this.form().showMe(this, "WorkOrderItemPartRequestOrderedDate") &&
        !this.value.userIsRestrictedType
      ) {
        headers.push({
          text: this.$ay.t("PurchaseOrderOrderedDate"),
          align: "right",
          value: "purchaseOrderDateViz"
        });
      }

      if (
        this.form().showMe(this, "WorkOrderItemPartRequestExpectedReceiveDate")
      ) {
        headers.push({
          text: this.$ay.t("PurchaseOrderExpectedReceiveDate"),
          align: "right",
          value: "purchaseOrderExpectedDateViz"
        });
      }

      //redundant; the poid suffices
      // if (this.form().showMe(this, "WorkOrderItemPartRequestOnOrder")) {
      //   headers.push({
      //     text: this.$ay.t("WorkOrderItemPartRequestOnOrder"),
      //     align: "center",
      //     value: "purchaseOrderOnOrderViz"
      //   });
      // }

      if (this.form().showMe(this, "WorkOrderItemPartRequestReceived")) {
        headers.push({
          text: this.$ay.t("WorkOrderItemPartRequestReceived"),
          align: "right",
          value: "received"
        });
      }

      return headers;
    },
    itemList: function() {
      return this.value.items[this.activeWoItemIndex].partRequests.map(
        (x, i) => {
          return {
            index: i,
            id: x.id,
            partNameViz: x.partNameViz,
            partWarehouseViz: x.partWarehouseViz,
            quantity: window.$gz.locale.decimalLocalized(
              x.quantity,
              this.pvm.languageName
            ),
            partDescriptionViz: x.partDescriptionViz,
            upcViz: x.upcViz,
            purchaseOrderViz: x.purchaseOrderViz,
            purchaseOrderIdViz: x.purchaseOrderIdViz,
            purchaseOrderDateViz: window.$gz.locale.utcDateToShortDateAndTimeLocalized(
              x.purchaseOrderDateViz,
              this.pvm.timeZoneName,
              this.pvm.languageName,
              this.pvm.hour12
            ),
            purchaseOrderExpectedDateViz: window.$gz.locale.utcDateToShortDateAndTimeLocalized(
              x.purchaseOrderExpectedDateViz,
              this.pvm.timeZoneName,
              this.pvm.languageName,
              this.pvm.hour12
            ),
            //redundant; the poid suffices purchaseOrderOnOrderViz: x.purchaseOrderOnOrderViz,
            received: window.$gz.locale.decimalLocalized(
              x.received,
              this.pvm.languageName
            )
          };
        }
      );
    },
    formState: function() {
      return this.pvm.formState;
    },
    formCustomTemplateKey: function() {
      return this.pvm.formCustomTemplateKey;
    },
    hasData: function() {
      return this.value.items[this.activeWoItemIndex].partRequests.length > 0;
    },
    hasSelection: function() {
      return this.activeItemIndex != null;
    },

    canDelete: function() {
      return (
        this.activeItemIndex != null &&
        this.canDeleteAll &&
        !this.value.userIsRestrictedType
      );
    },
    canDeleteAll: function() {
      return this.pvm.rights.change && !this.value.userIsRestrictedType;
    }

    //----
  },
  watch: {
    activeWoItemIndex(val, oldVal) {
      if (val != oldVal) {
        this.setDefaultView();
      }
    },
    gotoIndex(val, oldVal) {
      if (val != oldVal) {
        this.selectedRow = [{ index: val }];
        this.activeItemIndex = val;
        this.$nextTick(() => {
          const el = this.$refs.partrequesttopform;
          if (el) {
            el.scrollIntoView({ behavior: "smooth" });
          }
        });
      }
    }
  },
  created() {
    this.setDefaultView();
  },
  methods: {
    openPO(item) {
      if (
        item != null &&
        item.purchaseOrderIdViz != null &&
        item.purchaseOrderIdViz != 0
      ) {
        window.$gz.eventBus.$emit("openobject", {
          type: window.$gz.type.PurchaseOrder,
          id: item.purchaseOrderIdViz
        });
      }
    },
    unDeleteItem() {
      this.value.items[this.activeWoItemIndex].partRequests[
        this.activeItemIndex
      ].deleted = false;
      this.setDefaultView();
    },
    deleteItem() {
      this.value.items[this.activeWoItemIndex].partRequests[
        this.activeItemIndex
      ].deleted = true;
      this.setDefaultView();
      this.$emit("change");
    },
    deleteAllItem() {
      this.value.items[this.activeWoItemIndex].partRequests.forEach(
        z => (z.deleted = true)
      );
      this.setDefaultView();
      this.$emit("change");
    },
    setDefaultView: function() {
      //if only one record left then display it otherwise just let the datatable show what the user can click on
      if (this.value.items[this.activeWoItemIndex].partRequests.length == 1) {
        this.selectedRow = [{ index: 0 }];
        this.activeItemIndex = 0;
      } else {
        this.selectedRow = [];
        this.activeItemIndex = null; //select nothing in essence resetting a child selects and this one too clearing form
      }
    },
    handleRowClick: function(item) {
      this.activeItemIndex = item.index;
      this.selectedRow = [{ index: item.index }];
    },
    form() {
      return window.$gz.form;
    },
    itemRowClasses: function(item) {
      let ret = "";
      const isDeleted =
        this.value.items[this.activeWoItemIndex].partRequests[item.index]
          .deleted === true;

      const hasError = this.form().childRowHasError(
        this,
        `Items[${this.activeWoItemIndex}].PartRequests[${item.index}].`
      );

      if (isDeleted) {
        ret += this.form().tableRowDeletedClass();
      }
      if (hasError) {
        ret += this.form().tableRowErrorClass();
      }
      return ret;
    }
    //---
  }
};
</script>
